' duplicate.VBS V1.00 (C) yoshioka.teruo@nifty.com 2004-09-12
' duplicate.VBS searches duplicate files.

Option Explicit
Sub Usage()
WScript.Echo "Usage: CScript duplicate.VBS [-n|-c|-s|-d] folder" & _
vbCRLF & "-n: Name" & _
vbCRLF & "-c: Content" & _
vbCRLF & "-s: Size" & _
vbCRLF & "-d: Date" & _
""
WScript.Quit
End Sub

Dim Lines()
Dim LineCount
Dim Page
Const MaxLineCount=12
Dim fso
Dim arg
Dim Flag
Const fName=1
Const fComp=2
Const fSize=3
Const fDate=4
Dim sFolder

Set fso=CreateObject("Scripting.FileSystemObject")

For Each arg In WScript.Arguments
Select Case LCase(arg)
Case "-n"
  If Not IsEmpty(Flag) Then Call Usage
  Flag=fName
Case "-c"
  If Not IsEmpty(Flag) Then Call Usage
  Flag=fComp
Case "-s"
  If Not IsEmpty(Flag) Then Call Usage
  Flag=fSize
Case "-d"
  If Not IsEmpty(Flag) Then Call Usage
  Flag=fDate
Case Else
  If Not IsEmpty(sFolder) Then Call Usage
  Set sFolder=fso.GetFolder(arg)
End Select
Next

If IsEmpty(Flag) Then Flag=fComp
If IsEmpty(sFolder) Then Call Usage

Dim dic
Dim key
Dim Items
Dim Item
Dim UB
Dim k
Dim j
Dim m
Dim Names()
Dim seq
Dim rCompare

Set dic=CreateObject("Scripting.Dictionary")
Call FolderProc(sFolder)
If Flag=fComp Then
  For Each key In dic
    Items=dic.Item(key)
    UB=UBound(Items)
    For k=0 To UB-1
      m=0
      ReDim Preserve Names(m)
      Names(m)=Items(k)
      If Items(k)<>"" Then
        For j=k+1 To UB
          If Items(j)<>"" Then
            rCompare=Compare(Items(k),Items(j))
            If rCompare=fSame Then
              m=m+1
              ReDim Preserve Names(m)
              Names(m)=Items(j)
              Items(j)=""
            End If
          End If
        Next
      End If
      If m Then
        seq=seq+1
        For Each Item In Names
          Echo Join(Array(m+1,seq,Item))
        Next
      End If
    Next
  Next
Else
  For Each key In dic
    Items=dic.Item(key)
    If UBound(Items)>0 Then
      For Each Item In Items
        Echo Join(Array(UBound(Items)+1,key,Item))
      Next
    End If
  Next
End If
If LineCount>0 Then
  MsgBox Join(Lines,vbCrLf),,"page " & Page+1
End If
WScript.Quit

Function FolderProc(Folder)
Dim file
For Each file In Folder.SubFolders
  Call FolderProc(file)
Next

For Each file In Folder.Files
  Call FileProc(file)
Next
End Function

Function FileProc(file)
Dim key
Dim Items
Select Case Flag
Case fName key=UCase(file.Name)
Case fComp key=file.Size
Case fSize key=file.Size
Case fDate key=file.DateLastModified
End Select
If Not dic.Exists(key) Then
  dic.Add key,Array(file.Path)
Else
  Items=dic.Item(key)
  Redim Preserve Items(UBound(Items)+1)
  Items(UBound(Items))=file.Path
  dic.Item(key)=Items
End If
End Function

Const fSame=0
Const fNotSize=2
Const fNotContent=1

Function Compare(srcFile,dstFile)
  Dim Src
  Dim Dst
  Const adTypeBinary=1

  Compare=fSame
  Set Src=fso.GetFile(srcFile)
  Set Dst=fso.GetFile(dstFile)
  If Src.Size<>Dst.Size Then
    Compare=fNotSize
    Exit Function
  End If

  Set Src=CreateObject("ADODB.Stream")
  Call Src.Open()
  Src.Type=adTypeBinary
  Call Src.LoadFromFile(srcFile)

  Set Dst=CreateObject("ADODB.Stream")
  Dst.Type=adTypeBinary
  Call Dst.Open()
  Call Dst.LoadFromFile(dstFile)

  If Src.Size<>Dst.Size Then
    Compare=fNotSize
  Else
    Do Until Src.EOS
      If CStr(Src.Read(4096))<>CStr(Dst.Read(4096)) Then
       Compare=fNotContent
        Exit Do
      End If
    Loop
  End If
  Src.Close
  Dst.Close
  Set Src=Nothing
  Set Dst=Nothing
End Function

Sub Echo(str)
  On Error Resume Next
  WScript.StdOut.WriteLine str
  If Err=0 Then Exit Sub
  On Error GoTo 0
  If LineCount=MaxLineCount Then
    If vbCancel=MsgBox(Join(Lines,vbCrLf),vbOkCancel,"page " & Page+1) Then WScript.Quit
    LineCount=0
    Page=Page+1
  End If
  ReDim Preserve Lines(LineCount)
  Lines(LineCount)=str
  LineCount=LineCount+1
End Sub

